var dmp = new diff_match_patch();
function setCookie(cname, cvalue, exdays) {
    var d = new Date();
    d.setTime(d.getTime() + (exdays * 24 * 60 * 60 * 1000));
    var expires = "expires=" + d.toGMTString();
    document.cookie = cname + '=' + cvalue + ';path="/";' + expires;
}
setCookie("bookmark", document.URL, 30);
function get_url() {
  var url = window.location.href;
  url = url.substring(0, (url.indexOf("?") == -1) ? url.length : url.indexOf("?")); // verwijderen alle url parameters
  url = url.substring(url.lastIndexOf("/") + 1, url.length); // verwijderen pad
  url = url.substring(0, (url.indexOf(".") == -1) ? url.length : url.indexOf(".")); // verwijderen extensie
  return url;
}

function save_edit(unlink) {
  var formData = new FormData();

  var url = get_url();
  if (url=="") {
    url = "index";
  }
  formData.append("page", url);

  var editmelenght = document.getElementsByClassName("editme").length/2;

  for (var j = 0; j < editmelenght; j++) {
  	if (unlink) {
  	  enc = "unlink";
  	} else {
      // Diff aanmaken
      var text1 = document.getElementById("editori"+j).innerHTML;
      var text2 = document.getElementsByClassName("editme")[j].innerHTML;
  
      var diff = dmp.diff_main(text1, text2, true);
      var patch_list = dmp.patch_make(text1, text2, diff);
      var jsonString = JSON.stringify(patch_list);
      var enc = window.btoa(unescape(encodeURIComponent(jsonString)));
    }
    formData.append("data"+j, enc);
  }

  var xhr = new XMLHttpRequest();
  xhr.open('POST', 'elo/edit_save.php', true);
  
  xhr.onload = function(e) {
    if (this.status == 200) {
      alert(this.responseText);
      if (unlink) {
        location.reload();
      }
    }
  };

  xhr.send(formData);
}

function fold(el) {
   if (el.parentElement.style.height == "1.2em") {
      el.parentElement.style.height = "";
   } else {
      el.parentElement.style.height = "1.2em";
   }
}
function adjustMeuItem(e) {
  var lastmcemenu=document.getElementsByClassName("mce-menu").length - 1;
  document.getElementsByClassName("mce-menu")[lastmcemenu].style.width = '';
  document.getElementsByClassName("mce-menu")[lastmcemenu].style.minWidth = '19px';
  document.getElementsByClassName("mce-menu")[lastmcemenu].firstChild.style.width = '';
}
function resize() {
  var fontsize = Math.round(Math.min(window.innerWidth/48, window.innerHeight/68));
  var fontsize = Math.round(Math.min(window.innerWidth/8.5, window.innerHeight/12));
  document.body.style.fontSize = fontsize+"%";
}
function start_editor() {
// kopieer de originele tekst om later een diff te maken
  var editmelenght = document.getElementsByClassName("editme").length;
  for (var i = 0; i < editmelenght; i++) {
    var div = document.createElement('div');
    div.setAttribute('id', "editori"+i);
    div.setAttribute('style', 'display: none;');
    div.setAttribute('class', 'editme');
    document.body.appendChild(div);
    document.getElementById("editori"+i).innerHTML = document.getElementsByClassName("editme")[i].innerHTML;
  }
  tinymce.init({
    inline: true,
    language : 'nl',
    plugins: "textcolor",
    toolbar: "nieuw save edit undo redo bold italic underline alignment strikethrough forecolor backcolor",
    fixed_toolbar_container: "#mytoolbar",
    menubar : false,
    selector: "div.editme",

    setup : function(ed) {
      ed.on('init', function(e) {
        var editmelenght = document.getElementsByClassName("editme").length/2;
        if (e.target.id == 'editori'+(editmelenght-1)) {
          // aantekeningen toevoegen na voltooien alle tinymce initialisaties
          for (var i = 0; i < editmelenght; i++) {
            var varname = "patch_json" + i;
            if (typeof window[varname] !== 'undefined') {
                var text1 = document.getElementsByClassName('editme')[i].innerHTML;
                var patches = JSON.parse(decodeURIComponent(escape(window[varname])));
                var results = dmp.patch_apply(patches, text1);
                document.getElementsByClassName("editme")[i].innerHTML = results[0];
            }
          }
        }
      });
//       ed.on('ExecCommand',function(e){
//         alert(e.command, e.ui, e.value);        
//       })
      // Add a custom button
      ed.addButton('edit', {
          type: 'listbox',
	  title: 'Edit',
          icon: 'cut',
	  onClick: adjustMeuItem,
          onselect: function(e) {
            tinyMCE.execCommand(this.value());
          },
          values: [
              {style: 'width: 19px;', icon: 'cut', value: 'Cut', title: 'Cut'},
              {style: 'width: 19px;', icon: 'copy', value: 'Copy', title: 'Copy'},
              {style: 'width: 19px;', icon: 'paste', value: 'Paste', title: 'Paste'},
          ],
          onPostRender: function() {
            // Select the firts item by default
            this.value('JustifyLeft');
          }
      });
      ed.addButton('alignment', {
          type: 'listbox',
	  title: 'Alignment',
          icon: 'alignleft',
	  onClick: adjustMeuItem,
          onselect: function(e) {
            tinyMCE.execCommand(this.value());
          },
          values: [
              {style: 'width: 19px;', icon: 'alignleft', value: 'JustifyLeft', title: 'Align left'},
              {style: 'width: 19px;', icon: 'alignright', value: 'JustifyRight', title: 'Align right'},
              {style: 'width: 19px;', icon: 'aligncenter', value: 'JustifyCenter', title: 'Align center'},
              {style: 'width: 19px;', icon: 'alignjustify', value: 'JustifyFull', title: 'Justify'},
          ],
          onPostRender: function() {
            // Select the firts item by default
            this.value('JustifyLeft');
          }
      });
      ed.addButton('nieuw', {
          title : 'Alle notities wissen',
          icon : 'newdocument',
          onclick : function() {
            var r = confirm("Alle notities op deze pagina definitief verwijderen?");
            if (r == true) {
              save_edit(true);
            }
          }
      });
      ed.addButton('save', {
          title : 'Save',
          icon : 'save',
          onclick : function() {
            save_edit(false);
          }
      });
      ed.on("mousedown", function(e) {
// surfen naar bij klikken op een koppeling
        if (e.target.tagName == "A") {
          window.open(e.target.href,e.target.target);
          e.preventDefault();
          e.stopPropagation();
        }
      });
    }
  });
}

window.onload = function(){
  resize();
  window.addEventListener("resize", resize);
  // Notities laden
  var po = document.createElement('script'); 
  po.type = 'text/javascript'; 
  po.src = 'elo/edit_load.php?page=' + get_url();
  document.head.appendChild(po);
  // Inhoudsopgave laden
  var xmlhttp;
  xmlhttp=new XMLHttpRequest();
  xmlhttp.onreadystatechange=function() {
    if (xmlhttp.readyState==4 && xmlhttp.status==200) {
      document.getElementById("content").innerHTML=xmlhttp.responseText;
      fold(document.getElementById("content").getElementsByTagName("span")[0]);
      }
    }
  xmlhttp.open("POST","content.html",true);
  xmlhttp.send();
}
